; ************************************************************
; Die ist die Unit t6963.ASM
;
; written by A.Vogel	baer@aca-vogel.de
;
; Ver. 1.0      Date: 03.06.02
; ************************************************************





.equ t6963_port_data		= PORTC;		Data Port register
.equ t6963_port_data_dir	= DDRC;			Data Port DIR register
.equ t6963_port_data_pin	= pinc;
.equ t6963_port_ctrl		= PORTD;			Control Port register
.equ t6963_port_ctrl_dir	= DDRD;			Control Port DIR register
.equ t6963_ctrl_rd		= 7;			Bit Read
.equ t6963_ctrl_wr		= 6;			Bit Write
.equ t6963_ctrl_cmddta		= 5;			Bit Command\Data
.equ t6963_ctrl_en		= 4;			Bit Enable\







;**********************************
;clears graph display
;*********************************

t6963_clr_graph:

ldi r17,0;
ldi r18,2;
ldi r19,$24;
rcall t6963_sendcmd;

ldi r25,10;

t6963_clr_gr_1:
ldi r24,255;
t6963_clr_gr_2:
ldi r18,0;
ldi r19,$C0;
rcall t6963_sendcmd;
dec r24;
brne t6963_clr_gr_2;
dec r25;
brne t6963_clr_gr_1;






ret;
;**********************************
;clears text display
;*********************************

t6963_clr_text:

ldi r17,0;
rcall t6963_setxy;

ldi r22,192;

t6963_clr_text_1:
ldi r18,0;
ldi r19,$C0;
rcall t6963_sendcmd;
dec r22;
breq t6963_clr_text_end;
rjmp t6963_clr_text_1;





t6963_clr_text_end:
ret;

;*******************************************************************
; Init T6963 LC_Display. Needs approx 100ms
;
;*******************************************************************


t6963_init:

sbi t6963_port_ctrl_dir,t6963_ctrl_rd;		set ctrl RD to out
sbi t6963_port_ctrl_dir,t6963_ctrl_wr;		set ctrl WR to out
sbi t6963_port_ctrl_dir,t6963_ctrl_cmddta;	set ctrl cmd\dta to out
sbi t6963_port_ctrl_dir,t6963_ctrl_en;		set ctrl EN to out

ldi r22,255;
t6963_init_1:
ldi r16,225;
;rcall wait_long;
dec r22;
brne t6963_init_1;



ldi r17,0;
ldi r18,0;
ldi r19,$40;
rcall t6963_sendcmd;		RAM Text Adress


ldi r17,20;
ldi r18,0;
ldi r19,$41;
rcall t6963_sendcmd;		line length

ldi r17,0;
ldi r18,2;
ldi r19,$42;
rcall t6963_sendcmd;		Ram Graphic Home

ldi r17,20;
ldi r18,0;
ldi r19,$43;
rcall t6963_sendcmd;		line length Graphic




ldi r17,0;
ldi r18,0;
ldi r19,128;
rcall t6963_sendcmd;		Or mode, internal char



ldi r17,0;
ldi r18,0;
ldi r19,156;
rcall t6963_sendcmd;		text mode on

ldi r17,1;
ldi r18,1;
ldi r19,$21;
rcall t6963_sendcmd;		cursor settings

ldi r17,0;
ldi r18,0;
ldi r19,156;
rcall t6963_sendcmd;		


ret;







t6963_setdirout:
ldi r16,$FF;
out t6963_port_data_dir,r16;		set port dir reg to 255 (output)
ret;

t6963_setdirin:
ldi r16,$00;
out t6963_port_data_dir,r16;		set port dir reg to 0 (input)
ret;

;********************************************
; status check, returns r16>0 if ready for new data/cmd
;	        else r16=0
;********************************************
t6963_checkstat:

rcall t6963_setdirin;
sbi t6963_port_ctrl,t6963_ctrl_en;
sbi t6963_port_ctrl,t6963_ctrl_cmddta;
sbi t6963_port_ctrl,t6963_ctrl_wr;
cbi t6963_port_ctrl,t6963_ctrl_rd;

nop;
nop;
nop;
cbi t6963_port_ctrl,t6963_ctrl_en;
nop;
nop;
nop;
nop;
nop;
in r16,t6963_port_data_pin;
nop;
nop;
nop;
sbi t6963_port_ctrl,t6963_ctrl_en;
sbi t6963_port_ctrl,t6963_ctrl_rd;
andi r16,3;				mask status to Bit 0..1
cpi r16,3;
breq t6369_checkstat_end;
ldi r16,0;
t6369_checkstat_end: 

ret;

;*******************************************************************
; Sende CommandByte an  T6963 Display
; DatenByte in R17 (1) and r18 (2) Command in r19; 
;*******************************************************************

t6963_sendcmd:

push r16;


rcall t6963_senddata;
mov r17,r18;
rcall t6963_senddata;


rcall t6963_setdirout;			Cpu writes out
out t6963_port_data,r19;
sbi t6963_port_ctrl,t6963_ctrl_en;	ENable Hi
sbi t6963_port_ctrl,t6963_ctrl_cmddta;	C/D HI
sbi t6963_port_ctrl,t6963_ctrl_rd;	RD HI
cbi t6963_port_ctrl,t6963_ctrl_wr;	WR Low
cbi t6963_port_ctrl,t6963_ctrl_en;	ENable Lo
nop;
nop;
nop;
nop;

nop;
nop;
sbi t6963_port_ctrl,t6963_ctrl_en;	ENable Hi
sbi t6963_port_ctrl,t6963_ctrl_wr;	WR Hi
pop r16;
ret;

;*******************************************************************
; Sende DatenByte an  T6963 Display
; DatenByte in R17
; 
;*******************************************************************

t6963_senddata:
rcall t6963_checkstat;
cpi r16,0;
breq t6963_senddata;

rcall t6963_setdirout;			Cpu writes out
out t6963_port_data,r17;
sbi t6963_port_ctrl,t6963_ctrl_en;	ENable Hi
cbi t6963_port_ctrl,t6963_ctrl_cmddta;	C/D Low
sbi t6963_port_ctrl,t6963_ctrl_rd;	RD HI
cbi t6963_port_ctrl,t6963_ctrl_wr;	WR Low
cbi t6963_port_ctrl,t6963_ctrl_en;	ENable Lo
nop;
nop;
nop;
nop;
nop;
nop;

sbi t6963_port_ctrl,t6963_ctrl_en;	ENable Hi
sbi t6963_port_ctrl,t6963_ctrl_wr;	WR Low

ret;
;***********************************************
; Set data pointer to xy
; in:	xy=r17   (Position in Ram)
;**********************************************
t6963_setxy:
push r18;
push r19;
ldi r18,0;
ldi r19,$24;
rcall t6963_sendcmd;
pop r19;
pop r18;
ret;
;********************************
;writes text line to t6963 LCD Display
; ZH,ZL=Adress in ROM	line ends with 0 !
;*********************************
t6963_wr_rom_line:


push r18;
push r19;
push r17;
push r0;
ldi r17,0;

t6963_wr_rom_line_1:
	lpm				; Load byte from program memory into r0
	tst	r0			; Check if we've reached the end of the message
	breq	t6963_wr_rom_line_end	; If so, quit
	mov r18,r0;
	subi r18,$20;
	ldi r19,$C0			;
	rcall t6963_sendcmd		; Put the character to LCD
	adiw	ZL,1			; Increase Z registers
	rjmp	t6963_wr_rom_line_1;

t6963_wr_rom_line_end:

pop r0;
pop r17;
pop r19;
pop r18;













ret;
;********************************
;writes text line to t6963 LCD Display
; ZH,ZL=Adress in Ram	line ends with 0 !
;*********************************
t6963_wr_txt_line:


push r18;
push r19;
push r17;
push r0;
ldi r17,0;

t6963_wr_txt_line_1:
	ld	r0,Z			; Load byte from program memory into r0
	tst	r0			; Check if we've reached the end of the message
	breq	t6963_wr_txt_line_end	; If so, quit
	mov r18,r0;
	subi r18,$20;
	ldi r19,$C0			;
	rcall t6963_sendcmd		; Put the character to LCD
	adiw	ZL,1			; Increase Z registers
	rjmp	t6963_wr_txt_line_1;

t6963_wr_txt_line_end:

pop r0;
pop r17;
pop r19;
pop r18;



ret;


;**************************
;sets graphic on
;**************************
t6963_graphic:
push r17;
push r18;
push r19;
ldi r17,0;
ldi r18,0;
ldi r19,152;
rcall t6963_sendcmd;		gr mode on
pop r19;
pop r18;
pop r17;


ret;

;**************************
;sets graphic off
;**************************
t6963_text:
push r17;
push r18;
push r19;
ldi r17,0;
ldi r18,0;
ldi r19,156;
rcall t6963_sendcmd;		text mode on
pop r19;
pop r18;
pop r17;


ret;

;********************************************
; T6963 setpixel
; in:	ZL,ZH  adress !
;	r16,r17,r18	byte 1..3 to print
;*********************************************
t6963_setpixels:

push r16;
push r17;
push r18;
push r19;
push r21;
push r22;
push r23;
push r24;

mov r23,r17;
mov r24,r18;
mov r17,zl;		set pointer lcd
mov r18,zh;
ldi r19,$24;
rcall t6963_sendcmd;
mov r17,r23;
mov r18,r24;

ldi r21,6;			mod bit Counter
ldi r22,24;			loop cnter

t6963_setpixels_1:

ldi r19,$F8;
add r19,r21;			set setpixel cmd
subi r19,1;
sbrc r16,7;			bit 7=1? NO->skip next
rcall t6963_sendcmd_fast;

clc;				clr carry
rol r18;
rol r17;
rol r16;			shift all 1 bit left
dec r21
brne t6963_setpixels_5;		wrap bit 6
ldi r21,6;
adiw ZL,1;
mov r23,r17;
mov r24,r18;
mov r17,zl;		set pointer lcd
mov r18,zh;
ldi r19,$24;
rcall t6963_sendcmd;
mov r17,r23;
mov r18,r24;

t6963_setpixels_5:		

dec r22;
breq t6963_setpixels_end;

rjmp t6963_setpixels_1;			



t6963_setpixels_end:

pop r24;
pop r23;
pop r22;
pop r21;
pop r19;
pop r18;
pop r17;
pop r16;



ret;


;*******************************************************************
; Sende CommandByte an  T6963 Display
; Command in r19; No data will be written!
;*******************************************************************

t6963_sendcmd_fast:
push r16;

t6963_sendcmd_fast_1:
rcall t6963_checkstat;
cpi r16,0;
breq t6963_sendcmd_fast_1;


rcall t6963_setdirout;			Cpu writes out
out t6963_port_data,r19;

sbi t6963_port_ctrl,t6963_ctrl_en;	ENable Hi
sbi t6963_port_ctrl,t6963_ctrl_cmddta;	C/D HI
sbi t6963_port_ctrl,t6963_ctrl_rd;	RD HI
cbi t6963_port_ctrl,t6963_ctrl_wr;	WR Low
cbi t6963_port_ctrl,t6963_ctrl_en;	ENable Lo
nop;
nop;
nop;
nop;

nop;
nop;
sbi t6963_port_ctrl,t6963_ctrl_en;	ENable Hi
sbi t6963_port_ctrl,t6963_ctrl_wr;	WR Hi
pop r16;
ret;





